#include <stdio.h>
#include <stdlib.h>
#include <spu_intrinsics.h>
#include <spu_mfcio.h>

typedef struct spe_args {
	unsigned long long a;
	unsigned long long b;
	int id;
	int pad[3];
} spe_args_t;

int buf[32] __attribute__((aligned(16)));

int main(unsigned long long spe, unsigned long long argp,
		unsigned long long envp) {
	int i, tag = 1;
	mfc_list_element_t list[2];
	spe_args_t args __attribute__((aligned(16)));
	int *a, *b;

	// ARGS ̓ǂݍ
	spu_mfcdma64(&args, mfc_ea2h(argp), mfc_ea2l(argp), sizeof(spe_args_t),
			tag, MFC_GET_CMD);
	spu_writech(MFC_WrTagMask, 1 << tag);
	spu_mfcstat(MFC_TAG_UPDATE_ALL);

	// List 쐬
	for (i = 0; i < 2; i++) {
		list[i].notify = 0;
		list[i].reserved = 0;
		list[i].size = sizeof(int) * 16;
	}
	list[0].eal = mfc_ea2l(args.a) + args.id * 16 * sizeof(int);
	list[1].eal = mfc_ea2l(args.b) + args.id * 16 * sizeof(int);

	// obt@̈̃xt
	a = &(buf[0]);
	b = &(buf[16]);

	spu_mfcdma64(buf, mfc_ea2h(args.a), (unsigned int)&list, sizeof(list), 0, MFC_GETL_CMD);
	spu_writech(MFC_WrTagMask, 1 << 0);
	spu_mfcstat(MFC_TAG_UPDATE_ALL);

	//l傿傢ƕύX
	a[0]++;
	b[0]++;

	// ߂
	spu_mfcdma64(buf, mfc_ea2h(args.a), (unsigned int)&list, sizeof(list), 0, MFC_PUTL_CMD);
	spu_writech(MFC_WrTagMask, 1 << 0);
	spu_mfcstat(MFC_TAG_UPDATE_ALL);
	
	return EXIT_SUCCESS;

}

